Index: /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp	(revision 2560)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp	(revision 2575)
@@ -525,6 +525,8 @@
 	//TestEvaluation(sc);
 
+#ifdef PERFTIMER   
 	// fill view cells cache
 	mNodeTimer.Entry();
+#endif	
 
 	const BvhTraversalData &tData = sc.mParentData;
@@ -634,6 +636,8 @@
 	UpdateViewCells(sc);
 
+#ifdef PERFTIMER  
 	mNodeTimer.Exit();
-
+#endif
+	
 	// return the new interior node
 	return node;
@@ -647,6 +651,8 @@
 								)
 {
+#ifdef PERFTIMER  
 	mSubdivTimer.Entry();
-
+#endif
+	
 	BvhSubdivisionCandidate *sc = 
 		static_cast<BvhSubdivisionCandidate *>(splitCandidate);
@@ -718,6 +724,8 @@
 	}
 	
+#ifdef PERFTIMER  
 	mSubdivTimer.Exit();
-
+#endif
+	
 	return currentNode;
 }
@@ -780,5 +788,7 @@
 										   const bool preprocessViewCells)
 {
-	mPlaneTimer.Entry();
+#ifdef PERFTIMER  
+  mPlaneTimer.Entry();
+#endif
 
 	const BvhTraversalData &tData = splitCandidate.mParentData;
@@ -824,11 +834,14 @@
 	}
 
+#ifdef PERFTIMER  
 	mPlaneTimer.Exit();
-
+#endif
 
 	///////////////////
 
+#ifdef PERFTIMER  
 	mEvalTimer.Entry();
-
+#endif
+	
 	// mark view cells according to what part of the split they see
 	// and compute volume
@@ -984,5 +997,7 @@
 #endif
 
+#ifdef PERFTIMER  
 	mEvalTimer.Exit();
+#endif
 }
 
@@ -1676,6 +1691,7 @@
 													const int axis)											
 {
+#ifdef PERFTIMER  
 	mSortTimer.Entry();
-	
+#endif	
 	//-- insert object queries
 	ObjectContainer *objects = mUseGlobalSorting ? 
@@ -1684,5 +1700,7 @@
 	CreateLocalSubdivisionCandidates(*objects, &mSubdivisionCandidates, !mUseGlobalSorting, axis);
 	
+#ifdef PERFTIMER  
 	mSortTimer.Exit();
+#endif
 }
 
@@ -1840,6 +1858,8 @@
 										 bool useVisibilityBasedHeuristics)
 {
+#ifdef PERFTIMER  
 	mSplitTimer.Entry();
-
+#endif
+	
 	if (mIsInitialSubdivision)
 	{
@@ -1925,6 +1945,8 @@
 	backObjects = nBackObjects[bestAxis];
 
+#ifdef PERFTIMER  
 	mSplitTimer.Exit();
-
+#endif
+	
 	//cout << "val: " << nCostRatio[bestAxis] << " axis: " << bestAxis << endl;
 	return nCostRatio[bestAxis];
@@ -2276,6 +2298,8 @@
 	//-- use view cells cache
 
+#ifdef PERFTIMER  
 	mCollectTimer.Entry();
-
+#endif
+	
 	ViewCellContainer *objViewCells = obj->GetOrCreateViewCells();
 
@@ -2308,6 +2332,7 @@
 	}
 
+#ifdef PERFTIMER  
 	mCollectTimer.Exit();
-
+#endif
 	return (int)objViewCells->size();
 }
@@ -2320,5 +2345,7 @@
 										  const bool onlyUnmailedRays)
 {
+#ifdef PERFTIMER  
 	mCollectTimer.Entry();
+#endif
 	VssRayContainer::const_iterator rit, rit_end = obj->GetOrCreateRays()->end();
 
@@ -2362,5 +2389,7 @@
 	}
 
+#ifdef PERFTIMER  
 	mCollectTimer.Exit();
+#endif
 	return numRays;
 }
@@ -2436,5 +2465,7 @@
 								  const bool onlyUnmailedRays)
 {
+#ifdef PERFTIMER  
 	mCollectTimer.Entry();
+#endif
 	VssRayContainer::const_iterator rit, rit_end = obj->GetOrCreateRays()->end();
 
@@ -2478,5 +2509,7 @@
 	}
 
+#ifdef PERFTIMER  
 	mCollectTimer.Exit();
+#endif
 	return numRays;
 }
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ply.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ply.h	(revision 749)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ply.h	(revision 2575)
@@ -132,5 +132,5 @@
 
 /* memory allocation */
-extern char *my_alloc();
+extern char *my_alloc(int,int,char *);
 #define myalloc(mem_size) my_alloc((mem_size), __LINE__, __FILE__)
 
@@ -202,5 +202,4 @@
 extern int equal_strings(char *, char *);
 
-
 #ifdef __cplusplus
 }
@@ -208,3 +207,2 @@
 #endif /* !__PLY_H__ */
 
-
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/BoostPreprocessorThread.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/BoostPreprocessorThread.cpp	(revision 1867)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/BoostPreprocessorThread.cpp	(revision 2575)
@@ -4,9 +4,13 @@
 #include "SceneGraph.h"
 #include "Preprocessor.h"
-#include <boost/thread/thread.hpp>
+
+// ??????????????? commented by VH ????????????
+//#include <boost/thread/thread.hpp>
 
 namespace GtpVisibilityPreprocessor {
 
 
+#ifdef THREADS1
+  
 BoostPreprocessorThread::BoostPreprocessorThread(Preprocessor *p):
 PreprocessorThread(p), mThread(NULL)
@@ -51,3 +55,6 @@
 }
 
+#endif // THREADS1
+
+  
 }
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 2571)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 2575)
@@ -24,6 +24,8 @@
 #include "SamplingStrategy.h"
 #include "SceneGraph.h"
+
+#ifdef PERFTIMER  
 #include "Timer/PerfTimer.h"
-
+#endif // PERFTIMER
 
 #define USE_RAY_LENGTH_AS_CONTRIBUTION 0
@@ -39,8 +41,10 @@
 
 
+#ifdef PERFTIMER  
 PerfTimer viewCellCastTimer;
 PerfTimer pvsTimer;
 PerfTimer objTimer;
-
+#endif
+  
 // HACK
 const static bool SAMPLE_AFTER_SUBDIVISION = true;
@@ -66,4 +70,22 @@
 };
 
+
+
+struct SortableViewCellEntry {
+
+	SortableViewCellEntry() {}
+	SortableViewCellEntry(const float v, ViewCell *cell):mValue(v), mViewCell(cell) {}
+
+	float mValue;
+	ViewCell *mViewCell;
+
+  friend bool operator<(const SortableViewCellEntry &a, const SortableViewCellEntry &b);
+};
+
+
+inline bool
+operator<(const SortableViewCellEntry &a, const SortableViewCellEntry &b) {
+  return a.mValue < b.mValue;
+}
 
 ViewCellsManager::ViewCellsManager(ViewCellsTree *viewCellsTree):
@@ -1059,9 +1081,10 @@
 	int id;
 
+#ifdef PERFTIMER  
 	PerfTimer boxTimer;
 
 	boxTimer.Start();
 	boxTimer.Entry();
-	
+#endif	
 	for (int i = 0; i < numBoxes; ++ i)
 	{
@@ -1074,7 +1097,9 @@
 
 
+#ifdef PERFTIMER  
 	boxTimer.Exit();
 
 	Debug << numBoxes << " boxes loaded in " << boxTimer.TotalTime() << " secs" << endl;
+#endif
 }
 
@@ -1699,5 +1724,5 @@
 inline float EvalMergeCost(ViewCell *root, ViewCell *candidate)
 {
-	return root->GetPvs().GetPvsHomogenity(candidate->GetPvs());
+  return root->GetPvs().GetPvsHomogenity(candidate->GetPvs());
 }
 
@@ -1773,17 +1798,4 @@
 }
 
-
-struct SortableViewCellEntry {
-
-	SortableViewCellEntry() {}
-	SortableViewCellEntry(const float v, ViewCell *cell):mValue(v), mViewCell(cell) {}
-
-	float mValue;
-	ViewCell *mViewCell;
-
-	friend bool operator<(const SortableViewCellEntry &a, const SortableViewCellEntry &b) {
-		return a.mValue < b.mValue;
-	}
-};
 
 
@@ -2114,4 +2126,5 @@
 	}
 
+#ifdef PERFTIMER  
 	cout << "view cell cast time: " << viewCellCastTimer.TotalTime() << " s" << endl;
 	Debug << "view cell cast time: " << viewCellCastTimer.TotalTime() << " s" << endl;
@@ -2119,5 +2132,5 @@
 	cout << "pvs time: " << pvsTimer.TotalTime() << " s" << endl;
 	Debug << "pvs time: " << pvsTimer.TotalTime() << " s" << endl;
-	
+#endif	
 	return sum;
 }
@@ -2869,6 +2882,7 @@
 	ViewCell::NewMail();
 
+#ifdef PERFTIMER  
 	viewCellCastTimer.Entry();
-
+#endif
 	static ViewCellContainer viewCells;
 	static VssRay *lastVssRay = NULL;
@@ -2889,6 +2903,7 @@
 	}
 
+#ifdef PERFTIMER  
 	viewCellCastTimer.Exit();
-
+#endif
 	mSamplesStat.mViewCells += (int)viewCells.size();
 
@@ -2908,13 +2923,16 @@
 	Intersectable *terminationObj;
 
+#ifdef PERFTIMER  
 	objTimer.Entry();
-
+#endif
 	// obtain pvs entry (can be different from hit object)
 	terminationObj = ray.mTerminationObject;
 
+#ifdef PERFTIMER  
 	objTimer.Exit();
 
 	pvsTimer.Entry();
-
+#endif
+	
 	ViewCellContainer::const_iterator it = viewCells.begin();
 
@@ -2929,6 +2947,8 @@
 	}
 
+#ifdef PERFTIMER  
 	pvsTimer.Exit();
-
+#endif
+	
 	mSamplesStat.mPvsContributions += ray.mPvsContribution;
 	if (ray.mPvsContribution)
@@ -3460,5 +3480,6 @@
 							   const float filterSize,
 							   ObjectPvs &pvs,
-							   vector<AxisAlignedBox3> *filteredBoxes
+							   vector<AxisAlignedBox3> *filteredBoxes,
+							   const bool onlyNewObjects
 							   )
 {
@@ -3480,9 +3501,10 @@
 
 	if (!mUseKdPvs)
-	{	// first mark all objects from this pvs
-		while (pit.HasMoreEntries()) 	
-			pit.Next()->Mail();
-	}
-
+	{
+	  // first mark all objects from this pvs
+	  while (pit.HasMoreEntries()) 	
+		pit.Next()->Mail();
+	}
+	
 	int pvsSize = 0;
 	int nPvsSize = 0;
@@ -3548,5 +3570,15 @@
 
 		pit = basePvs.GetIterator();
-
+		
+		if (onlyNewObjects) {
+		  while (pit.HasMoreEntries()) {
+			// mail all objects from the original not to include them in the
+			// resulting pvs
+			Intersectable *obj = pit.Next(pvsData);
+			obj->Mail();
+		  }
+		  pit = basePvs.GetIterator();
+		}
+		
 		while (pit.HasMoreEntries()) 
 		{		
@@ -3631,8 +3663,8 @@
 		stats.mAvgFilterRadius /= (stats.mLocalFilterCount + stats.mGlobalFilterCount);
 	}
-
+	
 	//Debug << " nPvs size = " << pvs.GetSize() << endl;
 
-	if (!mUseKdPvs)
+	if (!mUseKdPvs && !onlyNewObjects)
 	{
 		PvsData pvsData;
@@ -7162,9 +7194,10 @@
 	CLEAR_CONTAINER(tmpRays);
 
+#ifdef PERFTIMER  
 	cout << "view cell cast time: " << viewCellCastTimer.TotalTime() << " s" << endl;
 	Debug << "view cell cast time: " << viewCellCastTimer.TotalTime() << " s" << endl;
-
 	cout << "pvs time: " << pvsTimer.TotalTime() << " s" << endl;
 	Debug << "pvs time: " << pvsTimer.TotalTime() << " s" << endl;
+#endif
 	
 	return sum;
@@ -7174,12 +7207,13 @@
 
 
-ViewCellsManager *ViewCellsManager::LoadViewCellsBinary(const string &filename, 
-														ObjectContainer &pvsObjects,
-														bool finalizeViewCells,
-														BoundingBoxConverter *bconverter)												 
-{
-	IN_STREAM stream(filename.c_str());
-
-	if (!stream.is_open())
+ViewCellsManager *
+ViewCellsManager::LoadViewCellsBinary(const string &filename, 
+									  ObjectContainer &pvsObjects,
+									  bool finalizeViewCells,
+									  BoundingBoxConverter *bconverter)												 
+{
+  IN_STREAM stream(filename.c_str());
+  
+  if (!stream.is_open())
 	{
 		Debug << "View cells loading failed: could not open file" << endl;
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2572)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2575)
@@ -5,5 +5,5 @@
 #include "ViewCellsManager.h"
 #include "SceneGraph.h"
-#include "Viewcell.h"
+#include "ViewCell.h"
 #include "Beam.h"
 #include "KdTree.h"
@@ -126,12 +126,12 @@
 void GlRenderer::RenderTriangle(TriangleIntersectable *object)
 {
-	Triangle3 &t = object->GetItem();
+  Triangle3 *t = &(object->GetItem());
 
 	glBegin(GL_TRIANGLES);
-	Vector3 normal = t.GetNormal();
+	Vector3 normal = t->GetNormal();
 	glNormal3f(normal.x, normal.y, normal.z);
-	glVertex3f(t.mVertices[0].x, t.mVertices[0].y, t.mVertices[0].z);
-	glVertex3f(t.mVertices[1].x, t.mVertices[1].y, t.mVertices[1].z);
-	glVertex3f(t.mVertices[2].x, t.mVertices[2].y, t.mVertices[2].z);
+	glVertex3f(t->mVertices[0].x, t->mVertices[0].y, t->mVertices[0].z);
+	glVertex3f(t->mVertices[1].x, t->mVertices[1].y, t->mVertices[1].z);
+	glVertex3f(t->mVertices[2].x, t->mVertices[2].y, t->mVertices[2].z);
 	glEnd();
 }
@@ -420,11 +420,11 @@
 		if ((*oi)->Type() == Intersectable::TRIANGLE_INTERSECTABLE) {
 			TriangleIntersectable *object = (TriangleIntersectable *)*oi;
-			Triangle3 &t = object->GetItem();
-
-			Vector3 normal = t.GetNormal();
+			Triangle3 *t = &(object->GetItem());
+
+			Vector3 normal = t->GetNormal();
 			glNormal3f(normal.x, normal.y, normal.z);
-			glVertex3f(t.mVertices[0].x, t.mVertices[0].y, t.mVertices[0].z);
-			glVertex3f(t.mVertices[1].x, t.mVertices[1].y, t.mVertices[1].z);
-			glVertex3f(t.mVertices[2].x, t.mVertices[2].y, t.mVertices[2].z);
+			glVertex3f(t->mVertices[0].x, t->mVertices[0].y, t->mVertices[0].z);
+			glVertex3f(t->mVertices[1].x, t->mVertices[1].y, t->mVertices[1].z);
+			glVertex3f(t->mVertices[2].x, t->mVertices[2].y, t->mVertices[2].z);
 
 		}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/common.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/common.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/common.h	(revision 2575)
@@ -21,8 +21,10 @@
 #include <limits.h>
 
-
+// use perftimer
+#define PERFTIMER
 
 namespace GtpVisibilityPreprocessor {
 
+  
 
 
@@ -45,5 +47,5 @@
 
 #if defined(__GNUC__) || defined(_MSC_VER)
-#define DIRCAT '.'
+//#define DIRCAT '.'
 #endif
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/BitVectorPvs.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/BitVectorPvs.h	(revision 2530)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/BitVectorPvs.h	(revision 2575)
@@ -79,5 +79,5 @@
 class BitVectorPvs//: public PvsBase<T>
 {
-	template<typename T, typename S> friend class BitVectorPvsIterator;
+  template<typename T1, typename S1> friend class BitVectorPvsIterator;
 
 public:
@@ -121,5 +121,5 @@
 	bool Find(T sample);
 
-	typename BitVectorPvsIterator<T, S> GetIterator() const;
+        BitVectorPvsIterator<T, S> GetIterator() const;
 
 	/** Compute continuous PVS difference 
@@ -145,5 +145,6 @@
 	void MergeInPlace(const BitVectorPvs<T, S> &a)
 	{
-		cerr << "bitvector: merge in place not implemented yet" << endl;
+	  std::cerr << "bitvector: merge in place not implemented yet"
+		    << std::endl;
 	}
 
@@ -167,6 +168,6 @@
 	int SubtractPvs(const BitVectorPvs<T, S> &pvs)
 	{
-		cerr << "not yet implemented" << endl;
-		return 0;
+	  std::cerr << "not yet implemented" << std::endl;
+	  return 0;
 	}
 
@@ -177,5 +178,5 @@
 										float &pvsEnlargement)
 	{
-		cerr << "not yet implemented" << endl;
+	  std::cerr << "not yet implemented" << std::endl;
 	}
 
@@ -284,5 +285,5 @@
 
 template <typename T, typename S>
-void BitVectorPvs<T, S>::Clear(const bool trim = true)
+void BitVectorPvs<T, S>::Clear(const bool trim)
 {
 	bit_vector::iterator bit, bit_end = mEntries.end();
@@ -309,9 +310,7 @@
 
 template <typename T, typename S>
-typename BitVectorPvsIterator<T, S> BitVectorPvs<T, S>::GetIterator() const
-{
-	BitVectorPvsIterator<T, S> pit(mEntries.begin(), mEntries.end());
-
-	return pit;
+BitVectorPvsIterator<T, S> BitVectorPvs<T, S>::GetIterator() const
+{
+  return BitVectorPvsIterator<T, S>(mEntries.begin(), mEntries.end());
 }
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Material.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Material.h	(revision 2173)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Material.h	(revision 2575)
@@ -30,4 +30,13 @@
 };
 
+
+// Forward declarations
+RgbColor RandomColor(const float a, const float b);
+
+// Mapping from interval 0.0-1.0 to RGB using "rainbow" color map
+// (range of hue from 0-240)
+RgbColor RainbowColorMapping(const float value);
+
+  
 
 class Material 
@@ -68,4 +77,6 @@
 
 
+extern Material RandomMaterial();
+
 }
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Exporter.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Exporter.cpp	(revision 2394)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Exporter.cpp	(revision 2575)
@@ -8,4 +8,5 @@
 #include "Polygon3.h"
 #include "TraversalTree.h"
+#include "Material.h"
 
 
@@ -71,5 +72,5 @@
 		else
 		{
-			SetForcedMaterial(RandomMaterial());
+		  SetForcedMaterial(RandomMaterial());
 		}
 		if (0) ExportGeometry(leaf->mObjects);	
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Matrix4x4.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Matrix4x4.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Matrix4x4.h	(revision 2575)
@@ -103,5 +103,52 @@
 };
 
+// forward declaration
+Matrix4x4 IdentityMatrix();
+Matrix4x4 Invert(const Matrix4x4 &M);	// Invert a given matrix
+Matrix4x4 Transpose(const Matrix4x4 &M);	// Transpose a given matrix
+
+// Create various types of matrix.
+Matrix4x4 IdentityMatrix();
+Matrix4x4 ZeroMatrix();
+Matrix4x4 TranslationMatrix(const Vector3 &Location);
+Matrix4x4 RotationXMatrix(float Angle);
+Matrix4x4 RotationYMatrix(float Angle);
+Matrix4x4 RotationZMatrix(float Angle);
+Matrix4x4 RotationYPRMatrix(float Yaw, float Pitch, float Roll);
+// about axis 'axis' by angle 'Angle'
+Matrix4x4 RotationAxisMatrix(const Vector3 &axis, float Angle);
+// create the rotation matrix that rotates 'vecFrom' to 'vecTo'
+Matrix4x4 RotationVectorsMatrix(const Vector3 &vecFrom,
+				const Vector3 &vecTo);
+  
+Matrix4x4 ScaleMatrix(float X, float Y, float Z);
+Matrix4x4 GenRotation(const Vector3 &x, const Vector3 &y,
+		      const Vector3 &z);
+Matrix4x4 QuadricMatrix(float a, float b, float c, float d, float e,
+			float f, float g, float h, float j, float k);
+// returns matrix for transforming normal
+Matrix4x4 NormalTransformMatrix(const Matrix4x4 &M);
+
+Matrix4x4 MirrorX();
+Matrix4x4 MirrorY();
+Matrix4x4 MirrorZ();
+Matrix4x4 RotationOnly(const Matrix4x4 &x);
+
+// Binary operators
+Matrix4x4 operator+ (const Matrix4x4 &A, const Matrix4x4 &B);
+Matrix4x4 operator- (const Matrix4x4 &A, const Matrix4x4 &B);
+Matrix4x4 operator* (const Matrix4x4 &A, float B);
+Matrix4x4 operator* (const Matrix4x4 &A, const Matrix4x4 &B);
+
+// friends returning Vector3
+Vector3 operator*(const Matrix4x4 &M, const Vector3 &v);
+Vector3 RotateOnly(const Matrix4x4 &M, const Vector3 &v);
+Vector3 TransformNormal(const Matrix4x4 &M, const Vector3 &v);
+Vector3 GetTranslation(const Matrix4x4 &M);
+
+  
 }
 
+
+
 #endif
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp	(revision 2569)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp	(revision 2575)
@@ -3,5 +3,5 @@
 #include <stack>
 
-
+#include "Material.h"
 #include "ViewCell.h"
 #include "Mesh.h"
@@ -14,6 +14,8 @@
 #include "Exporter.h"
 #include "BvHierarchy.h"
+
+#ifdef PERFTIMER  
 #include "Timer/PerfTimer.h"
-
+#endif
 
 namespace GtpVisibilityPreprocessor {
@@ -23,8 +25,8 @@
 #define TYPE_LEAF -3
 
+#ifdef PERFTIMER  
 static PerfTimer sPvsTimer;
 static PerfTimer sSearchTimer;
-
-
+#endif
 
 static inline bool ilt(Intersectable *obj1, Intersectable *obj2)
@@ -45,8 +47,8 @@
 
 typedef priority_queue<ViewCell *, vector<ViewCell *>, 
-					   myless<vector<ViewCell *>::value_type> > TraversalQueue;
-
-int ViewCell::sMailId = 10000;//2147483647;
-int ViewCell::sReservedMailboxes = 1;
+		       myless<vector<ViewCell *>::value_type> > TraversalQueue;
+
+int Intersectable::sMailId = 10000;//2147483647;
+int Intersectable::sReservedMailboxes = 1;
 
 float MergeCandidate::sRenderCostWeight = 0;
@@ -55,6 +57,6 @@
 // pvs penalty can be different from pvs size
 inline static float EvalPvsPenalty(const float pvs, 
-								   const float lower, 
-								   const float upper)
+				   const float lower, 
+				   const float upper)
 {
 	// clamp to minmax values
@@ -2686,6 +2688,7 @@
 	Intersectable *obj;
 
+#ifdef PERFTIMER  
 	sPvsTimer.Entry();
-
+#endif
 	int pvsSize;
 	stream.read(reinterpret_cast<char *>(&pvsSize), sizeof(int));
@@ -2703,5 +2706,7 @@
 	}
 
+#ifdef PERFTIMER
 	sPvsTimer.Exit();
+#endif	
 
 	return leaf;
@@ -2738,6 +2743,8 @@
 	queue<ViewCell *> tStack;
 
+#ifdef PERFTIMER  
 	sPvsTimer.Start();
-
+#endif
+	
 	mPvsIds = new int[pvsObjects.size()];
 
@@ -2774,6 +2781,8 @@
 	}
 
+#ifdef PERFTIMER  
 	Debug << "needed " << sPvsTimer.TotalTime() << " secs for pvs loading" << endl;
-
+#endif
+	
 	delete mPvsIds;
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/SimpleRay.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/SimpleRay.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/SimpleRay.h	(revision 2575)
@@ -5,9 +5,23 @@
 using namespace std;
 #include "Vector3.h"
+#include "Ray.h"
 
 namespace GtpVisibilityPreprocessor {
 
+class Intersectable;
+
+// This is the result of ray tracing with a simple ray
+struct IntersectionStr {
+  Intersectable *intersectable;
+  float          tdist;
+  float          maxt;
+  int            pad1; // aligned to 16 bytes
+};
+  
 struct SimpleRay
 {
+  // This is stored result for the rays in the container
+  // having 16 rays - shooting rays in both directions
+  static IntersectionStr IntersectionRes[32];
   
   Vector3 mOrigin;
@@ -29,5 +43,6 @@
   // 4B
 
-  // TOTAL = 40B
+  // TOTAL = 40B - aligned by 8 Bytes only! - it might be
+  // padding to 48 Bytes here !
 
 
@@ -39,42 +54,59 @@
   
   SimpleRay(const Vector3 &o,
-			const Vector3 &d,
-			const unsigned char distribution,
-			const float weight,
-			const unsigned char flags = F_BIDIRECTIONAL
-			):
-	mOrigin(o),
-	mDirection(d),
-	mFlags(flags),
-	mType(Ray::LOCAL_RAY),
-	mDistribution(distribution)
-	//	, mWeight(weight)
+	    const Vector3 &d,
+	    const unsigned char distribution,
+	    const float weight,
+	    const unsigned char flags = F_BIDIRECTIONAL
+	    ):
+    mOrigin(o),
+    mDirection(d),
+    mFlags(flags),
+    mType(Ray::LOCAL_RAY),
+    mDistribution(distribution)
+    //	, mWeight(weight)
   {	
-	//	mId = sSimpleRayId++;
+    //	mId = sSimpleRayId++;
   }
 
+  void
+  Set(const Vector3 &o,
+      const Vector3 &d,
+      const unsigned char distribution,
+      const float weight,
+      const unsigned char flags = F_BIDIRECTIONAL
+      )
+  {
+    mOrigin = o;
+    mDirection = d,
+    mFlags = flags;
+    mType = Ray::LOCAL_RAY;
+    mDistribution = distribution;
+    //	, mWeight(weight)
+    //	mId = sSimpleRayId++;
+  }
+  
   bool IsBidirectional() const { return mFlags & F_BIDIRECTIONAL; }
 
   void SetBidirectional(const bool b) {
-	if (b)
-	  mFlags |= F_BIDIRECTIONAL;
-	else
-	  mFlags &= ~F_BIDIRECTIONAL;
+    if (b)
+      mFlags |= F_BIDIRECTIONAL;
+    else
+      mFlags &= ~F_BIDIRECTIONAL;
   }
   
   float GetParam(const int axis) const {
-	if (axis < 3)
-	  return mOrigin[axis];
-	else
-	  return mDirection[axis-3];
+    if (axis < 3)
+      return mOrigin[axis];
+    else
+      return mDirection[axis-3];
   }
   
   Vector3 Extrap(const float t) const {
-	  return mOrigin + mDirection * t;
+    return mOrigin + mDirection * t;
   }
 
   friend std::ostream &operator<<(std::ostream &s, const SimpleRay &r)
   {
-	  return s << "origin=" << r.mOrigin << " dir=" << r.mDirection;
+    return s << "origin=" << r.mOrigin << " dir=" << r.mDirection;
   };
 };
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.h	(revision 2350)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.h	(revision 2575)
@@ -14,6 +14,8 @@
 #include "IntersectableWrapper.h"
 #include "HierarchyManager.h"
+
+#ifdef PERFTIMER
 #include "Timer/PerfTimer.h"
-
+#endif // PERFTIMER
 
 namespace GtpVisibilityPreprocessor {
@@ -213,4 +215,6 @@
 	
 	int CastRay(Ray &ray) { return 0; }
+        int CastSimpleRay(const SimpleRay &ray) { return 0;}
+        int CastSimpleRay(const SimpleRay &ray, int IndexRay) { return 0;}
 	
 	bool IsConvex() const { return true; }
@@ -677,4 +681,5 @@
 	void CreateUniqueObjectIds();
 
+#ifdef PERFTIMER  
 	PerfTimer mNodeTimer;
 	PerfTimer mSubdivTimer;
@@ -684,4 +689,5 @@
 	PerfTimer mSortTimer;
 	PerfTimer mCollectTimer;
+#endif  
 
 protected:
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Plane3.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Plane3.cpp	(revision 2124)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Plane3.cpp	(revision 2575)
@@ -42,5 +42,5 @@
   const float det = md.Det3x3();
 
-  if (abs(det)<TRASH)
+  if (fabs(det) < TRASH)
     return false;
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/IntersectableWrapper.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/IntersectableWrapper.cpp	(revision 2571)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/IntersectableWrapper.cpp	(revision 2575)
@@ -4,4 +4,5 @@
 #include "KdTree.h"
 #include "BvHierarchy.h"
+#include "SimpleRay.h"
 
 
@@ -11,41 +12,77 @@
 AxisAlignedBox3 TriangleIntersectable::GetBox() const
 {	
-	return mItem.GetBoundingBox();
-}
-
-
+  return mItem.GetBoundingBox();
+}
+
+
+int
+TriangleIntersectable::CastSimpleRay(const SimpleRay &ray)
+{
+  static Vector3 nearestNormal;
+  // std::cout << "To be done - ray triangle intersection\n" << std::endl;
+  const int hitCode = mItem.CastSimpleRay(ray,
+					  SimpleRay::IntersectionRes[0].tdist,
+					  SimpleRay::IntersectionRes[0].maxt);
+  if (hitCode == Ray::INTERSECTION) {
+    SimpleRay::IntersectionRes[0].intersectable = this;
+    SimpleRay::IntersectionRes[0].maxt = SimpleRay::IntersectionRes[0].tdist;
+    return 1; // intersection occured
+  }
+  return 0; // no intersection
+}
+
+int
+TriangleIntersectable::CastSimpleRay(const SimpleRay &ray, int rayIndex)
+{
+  const int hitCode =
+    mItem.CastSimpleRay(ray,
+			SimpleRay::IntersectionRes[rayIndex].tdist,
+			SimpleRay::IntersectionRes[rayIndex].maxt);
+  if (hitCode == Ray::INTERSECTION) {
+    SimpleRay::IntersectionRes[rayIndex].intersectable = this;
+    // we copy the closest distance so far - it prunes the search
+    // when more triangles in the same leaf and assures the
+    // correctness.
+    SimpleRay::IntersectionRes[rayIndex].maxt =
+      SimpleRay::IntersectionRes[rayIndex].tdist;
+    return 1; // intersection occured
+  }
+  return 0; // no intersection
+}
+
+  
 int TriangleIntersectable::CastRay(Ray &ray)
 {	
-	float nearestT = MAX_FLOAT;
-	float t;
-	Vector3 nearestNormal;
-
-	if (ray.GetType() == Ray::LOCAL_RAY && !ray.intersections.empty())
-		nearestT = ray.intersections[0].mT;
+  float nearestT = MAX_FLOAT;
+  float t;
+  Vector3 nearestNormal;
+  
+  if (ray.GetType() == Ray::LOCAL_RAY && !ray.intersections.empty())
+    nearestT = ray.intersections[0].mT;
+  
+  const int hitCode = mItem.CastRay(ray, t, nearestT, nearestNormal);
+  
+  nearestT = t;
+  
+  if (hitCode == Ray::INTERSECTION) {
+    if (ray.GetType() == Ray::LOCAL_RAY && !ray.intersections.empty()) {
+      ray.intersections[0] = Ray::Intersection(nearestT,
+					       nearestNormal,
+					       this,
+					       0);
+    }
+    else {
+      ray.intersections.push_back(Ray::Intersection(nearestT,
+						    nearestNormal,
+						    this,
+						    0));
+    }
+    
+    return 1;
+  }
+  
+  return 0;
+}
 	
-	const int hitCode = mItem.CastRay(ray, t, nearestT, nearestNormal);
-
-	nearestT = t;
-
-	if (hitCode == Ray::INTERSECTION) {
-		if (ray.GetType() == Ray::LOCAL_RAY && !ray.intersections.empty()) {
-			ray.intersections[0] = Ray::Intersection(nearestT,
-													 nearestNormal,
-													 this,
-													 0);
-		}
-		else {
-			ray.intersections.push_back(Ray::Intersection(nearestT,
-														  nearestNormal,
-														  this,
-														  0));
-		}
-		
-		return 1;
-	}
-	
-	return 0;
-}
-	
 
 int TriangleIntersectable::NumberOfFaces() const
@@ -55,7 +92,8 @@
 
 
-Vector3 TriangleIntersectable::GetNormal(const int idx) const
-{
-	return mItem.GetNormal();
+Vector3
+TriangleIntersectable::GetNormal(const int idx) const
+{
+  return mItem.GetNormal();
 }
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/AxisAlignedBox3.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/AxisAlignedBox3.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/AxisAlignedBox3.h	(revision 2575)
@@ -61,4 +61,6 @@
   void Enlarge (const Vector3 &v);
 
+  void EnlargeToMinSize();
+  
   void SetMin(const Vector3 &v);
 
@@ -232,7 +234,7 @@
   
   int  ComputeMinMaxT(const Vector3 &origin,
-					  const Vector3 &direction,
-					  float *tmin,
-					  float *tmax) const;
+		      const Vector3 &direction,
+		      float *tmin,
+		      float *tmax) const;
 	
   // Compute tmin and tmax for a ray, whenever required .. need not pierce box
@@ -241,8 +243,8 @@
   // Compute tmin and tmax for a ray, whenever required .. need not pierce box
   int ComputeMinMaxT(const Ray &ray,
-					 float *tmin,
-					 float *tmax,
-					 EFaces &entryFace,
-					 EFaces &exitFace) const;
+		     float *tmin,
+		     float *tmax,
+		     EFaces &entryFace,
+		     EFaces &exitFace) const;
   
   // If a ray pierces the box .. returns 1, otherwise 0.
@@ -251,5 +253,5 @@
   // computes the signed distances for case: tmin < tmax and tmax > 0
   int GetMinMaxT(const Ray &ray, float *tmin, float *tmax,
-				 EFaces &entryFace, EFaces &exitFace) const;
+		 EFaces &entryFace, EFaces &exitFace) const;
   
   // Writes a brief description of the object, indenting by the given
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/IntelRayCaster.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/IntelRayCaster.cpp	(revision 2574)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/IntelRayCaster.cpp	(revision 2575)
@@ -14,9 +14,10 @@
 
 FILE *fileOut = 0;
-bool saveRays = true;
-  const int saveRaysStart = 3000000;
+bool saveRays = false;
+const int saveRaysStart = 3000000;
 int cntSavedRaysFLUSH = 0;
 unsigned long int cntSavedRays = 0;
 const int intSavedLIMIT = 1024;
+
 void
 InitSaving()
@@ -33,6 +34,4 @@
   fclose(fileOut);
 }
-
-  
 
 IntelRayCaster::IntelRayCaster(const Preprocessor &preprocessor, 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.h	(revision 2575)
@@ -1099,6 +1099,8 @@
   PushRoots(std::stack<RssTreeNode *> &st) const;
 
-  void
-  PushRoots(std::stack<RayTraversalData> &st, RssTreeNode::RayInfo &info) const;
+  typedef std::stack<RayTraversalData> TstackEntry;
+
+  void
+  PushRoots(TstackEntry &st, RssTreeNode::RayInfo &info) const;
 
   void
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Camera.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Camera.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Camera.h	(revision 2575)
@@ -9,5 +9,5 @@
 class KdTree;
 class SceneGraph;
-
+class RayCaster;
 
 class Camera
@@ -30,4 +30,11 @@
     mFovy = 90.0f*(float)M_PI/180.0f;
   }
+
+  Camera(int width, int height) {
+    mWidth = width;
+    mHeight = height;
+    mFovy = 90.0f*(float)M_PI/180.0f;
+  }
+
   
   void Precompute() {
@@ -46,5 +53,5 @@
   }
 
-	void SetDirection(const Vector3 &dir) {
+  void SetDirection(const Vector3 &dir) {
     mDirection = dir;
     Precompute();
@@ -53,5 +60,5 @@
   void LookInBox(const AxisAlignedBox3 &box)
   {
-    mDirection = Vector3(0,0,1); 
+    mDirection = Vector3(0,0,1);
     mPosition = box.Center();
     Precompute();
@@ -67,11 +74,26 @@
   
   bool
-	  SnapImage(std::string filename,
-			KdTree *tree,
-			SceneGraph *sceneGraph
-			);
+  SnapImage(std::string filename,
+	    KdTree *tree,
+	    SceneGraph *sceneGraph
+	    );
 
+  bool
+  SnapImage(std::string filename,
+	    RayCaster *raycaster,
+	    AxisAlignedBox3 &bbox,
+	    SceneGraph *sceneGraph
+	    );
+
+  bool
+  SnapImagePacket(std::string filename,
+		  RayCaster *raycaster,
+		  AxisAlignedBox3 &bbox,
+		  SceneGraph *sceneGraph
+		  );
+  
   void SetupRay(Ray &ray, const int x, const int y);
 
+  void SetupRay(SimpleRay &ray, const int x, const int y);
 };
 
